// EK001Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "EK001.h"
#include "EK001Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEK001Dlg dialog

CEK001Dlg::CEK001Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEK001Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEK001Dlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CEK001Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEK001Dlg)
	DDX_Control(pDX, IDC_LED1, m_cLED1);
	DDX_Control(pDX, IDC_LED2, m_cLED2);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CEK001Dlg, CDialog)
	//{{AFX_MSG_MAP(CEK001Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_LED1_ON, OnButtonLed1On)
	ON_BN_CLICKED(IDC_BUTTON_LED1_OFF, OnButtonLed1Off)
	ON_BN_CLICKED(IDC_BUTTON_LED2_ON, OnButtonLed2On)
	ON_BN_CLICKED(IDC_BUTTON_LED2_OFF, OnButtonLed2Off)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEK001Dlg message handlers

BOOL CEK001Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	//sprintf(pcDriverName, "Ezusb-%d", i);

	m_csDevName = "Ezusb-0";

	if(!bOpenDriver(&m_hDev, m_csDevName))
	{
		MessageBox("Could not find Driver! \nPlease Check the connection  ");
		OnOK();										// Close Dialog Program
	}
	else
	{
		CloseHandle(m_hDev);
	}


	LPTSTR lpBitmapName;
	lpBitmapName = MAKEINTRESOURCE(IDB_LEDRED);
	HBITMAP hbitmap = ::LoadBitmap(AfxGetInstanceHandle(), lpBitmapName);

	CStatic* pcS = (CStatic*)GetDlgItem(IDC_LED_RED);
	pcS->SetBitmap(hbitmap);


	lpBitmapName = MAKEINTRESOURCE(IDB_LEDBLUE);
	hbitmap = ::LoadBitmap(AfxGetInstanceHandle(), lpBitmapName);
	pcS = (CStatic*)GetDlgItem(IDC_LED_BLUE);
	pcS->SetBitmap(hbitmap);


	SetTimer(100, 100, NULL);		// ID 100, Period 100msec

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CEK001Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CEK001Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CEK001Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


#include <winioctl.h>
#define BASE_IOCTL_INDEX					0x0800
#define IOCTL_EZUSB_BULK_READ				CTL_CODE(FILE_DEVICE_UNKNOWN,  \
											BASE_IOCTL_INDEX+19,\
											METHOD_OUT_DIRECT,  \
											FILE_ANY_ACCESS)
#define IOCTL_EZUSB_BULK_WRITE				CTL_CODE(FILE_DEVICE_UNKNOWN,  \
											BASE_IOCTL_INDEX+20,\
											METHOD_IN_DIRECT,  \
											FILE_ANY_ACCESS)




void CEK001Dlg::OnButtonLed1On() 
{
	// TODO: Add your control notification handler code here
	USBBulkOut(1);
//	m_cLED1.SetState(1);

}

void CEK001Dlg::OnButtonLed1Off() 
{
	// TODO: Add your control notification handler code here
	USBBulkOut(2);
//	m_cLED1.SetState(0);
}

void CEK001Dlg::OnButtonLed2On() 
{
	// TODO: Add your control notification handler code here
	USBBulkOut(3);

}

void CEK001Dlg::OnButtonLed2Off() 
{
	// TODO: Add your control notification handler code here
	USBBulkOut(4);
//	m_cLED2.SetState(0);
}

BOOL CEK001Dlg::bOpenDriver(HANDLE *phDev, CString csDevName)
{

	CString csName = "\\\\.\\";
	csName += csDevName;

    *phDev = CreateFile(	csName,
							GENERIC_WRITE,
							FILE_SHARE_WRITE,
							NULL,
							OPEN_EXISTING,
							0,
							NULL);

    if (*phDev == INVALID_HANDLE_VALUE)
	{
        return (FALSE);
    } 
	else 
	{
        return (TRUE);
    } 

}


BOOL CEK001Dlg::USBBulkOut(BYTE code)
{

	BOOL	bRet;
//	BYTE	inBuf[64];
	BYTE	outBuf[64];
	DWORD	nByte;
	ULONG	nPipe;

	nPipe = 1;
	outBuf[0] = code;								// LED1 control code

	if(bRet = bOpenDriver(&m_hDev, m_csDevName))	// Driver opened
	{
		bRet = DeviceIoControl(
								m_hDev,
								IOCTL_EZUSB_BULK_WRITE, 
								&nPipe,
								sizeof(nPipe),
								outBuf,
								sizeof(outBuf),
								&nByte,
								NULL);
		CloseHandle (m_hDev);
	}
	else
	{
		MessageBox("Could not open the Device");
	}

	return bRet;
}


BYTE CEK001Dlg::USBBulkIn(void *buf)
{
	BOOL	bRet;
//	BYTE	inBuf[64];
	BYTE	outBuf[64];
	DWORD	nByte;
	ULONG	nPipe;

	nPipe = 0;
//	outBuf[0] = code;								// LED1 control code

	if(bRet = bOpenDriver(&m_hDev, m_csDevName))	// Driver opened
	{
		bRet = DeviceIoControl(
								m_hDev,
								IOCTL_EZUSB_BULK_READ, 
								&nPipe,
								sizeof(nPipe),
								outBuf,
								sizeof(outBuf),
								&nByte,
								NULL);
		CloseHandle (m_hDev);
	}
	else
	{
	//	MessageBox("Could not open the Device");
	}

	return outBuf[0];

}

void CEK001Dlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	BYTE in;

	in = USBBulkIn(&in);

	if(in & 0x2)					// LED1 off
	{
		m_cLED1.SetState(0);
	}
	else
	{
		m_cLED1.SetState(1);
	}

	if(in & 0x1)					// LED2 off
	{
		m_cLED2.SetState(0);
	}
	else
	{
		m_cLED2.SetState(1);
	}

	CDialog::OnTimer(nIDEvent);
}
